/*
 * INNOV-2: Build a Better Web Interface Using AJAX
 *
 * example3.p
 *
 * This program generates a html page that uses AjAX to set the options in
 * multiple combo-boxes and retrieve information about the selected breakout
 * sessions.
 */

{cgidefs.i}

Define variable SessionCount          as  integer no-undo.
Define variable ResponseHandlerCode   as   character no-undo.

{&OUT}
  '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" '
  '"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' skip( 1 )
  '<html>' skip
  '<head>' skip
  '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />'
  skip
  '<meta http-equiv="Pragma" content="no-cache" />' skip
  '<link rel="stylesheet" href="/innov-2.css" />' skip( 1 )
  '<title>INNOV-2: Example 3 - AJAX</title>' skip( 1 ).

assign ResponseHandlerCode =
  "if (xmlResponse.tagName == 'sessions') ~{setSesOptions(xmlResponse);~}\n" +
  "if (xmlResponse.tagName == 'timeslots') ~{setTSOptions(xmlResponse);~}\n" +
  "if (xmlResponse.tagName == 'session-detail') ~{showSesDetail(xmlResponse);~}\n".

{ajaxreq.i &ResponseHandler = "ResponseHandlerCode"}

{&OUT}
  '<script language="javascript" type="text/javascript">'
  '<!--//--><![CDATA[//><!--' skip
  '// chgTSOptions() gets executed when the value of the date combo-box changes'
  skip
  'function chgTSOptions() ~{' skip
  '    //  Blank out the current options for the combo-boxes, ' skip
  '    //  and any current detail values' skip
  '    document.demoform.ts.length = 0;' skip
  '    document.demoform.ts[0] = new Option("Choose","");' skip
  '    document.demoform.ses.length = 0;' skip
  '    document.demoform.ses[0] = new Option("Choose a Session","");' skip
  '    document.getElementById("speaker").innerHTML = "";' skip
  '    document.getElementById("sesdesc").innerHTML = "";' skip

  '    //  Initiate the AJAX request' skip
  '    ajaxRequest("' get-value("SCRIPT_NAME" )
                   '?prog=ajaxts.p&sendxml=1&sdate=" + '
                   'document.demoform.sdate.value)' skip
  '~} // chgTSOptions()' skip( 1 )

  '// chgSesOptions() get executed when the value of the timeslot combo-box changes' skip
  'function chgSesOptions() ~{' skip
  '    //  Blank out the current options for the session combo-box, ' skip
  '    //  and any current detail values' skip
  '    document.demoform.ses.length = 0;' skip
  '    document.demoform.ses[0] = new Option("Choose a Session","");' skip
  '    document.getElementById("speaker").innerHTML = "";' skip
  '    document.getElementById("sesdesc").innerHTML = "";' skip

  '    //  Initiate the AJAX request' skip
  '    ajaxRequest("' get-value("SCRIPT_NAME" )
                   '?prog=ajaxses.p&sendxml=1&sdate=" + '
                   'document.demoform.sdate.value + "&ts=" + '
                   'document.demoform.ts.value)' skip
  '~} // chgSesOptions()' skip.
{&OUT}
  '// getSesDetail() gets executed when a session is chosen' skip
  'function getSesDetail() ~{' skip
  '    //  Blank out any existing session details' skip
  '    document.getElementById("speaker").innerHTML = "";' skip
  '    document.getElementById("sesdesc").innerHTML = "";' skip

  '    //  Initiate the AJAX request' skip
  '    var sesID = document.demoform.ses.value;' skip
  '    ajaxRequest("' get-value("SCRIPT_NAME" )
                   '?prog=ajaxsesdet.p&sendxml=1&sid=" + sesID);' skip
  '~} // getSesDetail()' skip( 1 ).
{&OUT}
  '// setTSOptions processes the AJAX response for time slots' skip
  'function setTSOptions(xmlTimeSlots) ~{' skip
  '    var timeslots=xmlTimeSlots.getElementsByTagName("timeslot");' skip
  '    for (var i=0;i<timeslots.length;i++) ~{' skip
  '        document.demoform.ts[i+1] = '
           'new Option(timeslots[i].firstChild.data,' +
           'timeslots[i].firstChild.data.replace(":",""));' skip
  '    ~}' skip
  '~} // setTSOptions(xmlTimeSlots)' skip( 1 ).
{&OUT}
  '// setSesOptions processes the AJAX response for sessions' skip
  'function setSesOptions(xmlSessions) ~{' skip
  '    var sessions=xmlSessions.getElementsByTagName("session");' skip
  '    for (var i=0;i<sessions.length;i++) ~{' skip
  '        document.demoform.ses[i+1] = '
           'new Option(sessions[i].firstChild.data,'
                      'sessions[i].firstChild.data.split(":")[0]);' skip
  '    ~}' skip
  '~} // setSesOptions(xmlSesDetail)' skip( 1 ).
{&OUT}
  '// showSesDetail processes the AJAX response for session details' skip
  'function showSesDetail(xmlSesDetail) ~{' skip
  '    //  Display the session speaker' skip
  '    dataNode = xmlSesDetail.getElementsByTagName("speaker")[0].firstChild;'
  skip
  '    if (dataNode != null) ~{' skip
  '        document.getElementById("speaker").innerHTML = unescape(dataNode.data);' skip
  '    ~} else ~{' skip
  '        document.getElementById("speaker").innerHTML = "";' skip
  '    ~}' skip
  '    //  Display the session description' skip
  '    dataNode = xmlSesDetail.getElementsByTagName("sdesc")[0].firstChild;'
  skip
  '    if (dataNode != null) ~{' skip
  '        document.getElementById("sesdesc").innerHTML = unescape(dataNode.data);' skip
  '    ~} else ~{' skip
  '        document.getElementById("sesdesc").innerHTML = "";' skip
  '    ~}' skip
  '~} // showSesDetail(xmlSesDetail)' skip.
{&OUT}
  '//--><!]]></script>' skip( 1 )
  '</head>' skip( 1 )
  '<body>' skip( 1 )
  '<p />' skip
  '<div align="center">' skip
  '<blockquote>This is a more advanced example using AJAX to set the options'
  ' in multiple combo-boxes based on the other selections, and retrieve'
  ' information about each breakout session.'
  '</blockquote>' skip( 1 )
  '<form name="demoform">' skip
  '<table align="center">' skip
  '<tr><th>Conference Date:</th><td width="600"><select id="sdate" name="sdate" onChange="chgTSOptions();">' skip
  '  <option selected="selected">Choose Date</option>' skip
  '  <option value="06/05/2006">June 5, 2006</option>' skip
  '  <option value="06/06/2006">June 6, 2006</option>' skip
  '  <option value="06/07/2006">June 7, 2006</option>' skip
  '</select></td></tr>' skip
  '<tr><th>Time Slot:</th><td><select id="ts" name="ts" onChange="chgSesOptions();">' skip
  '</select></td></tr>' skip
  '<tr><th>Breakout Session:</th><td><select id="ses" name="ses" onChange="getSesDetail();">' skip
  '</select></td></tr>' skip
  '<tr><th>Speakers:</th><td id="speaker"></td></tr>' skip
  '<tr><th valign="top">Description:</th><td id="sesdesc"></td></tr>' skip
  '</table>' skip
  '</form>' skip
  '</div>' skip
  '</body>' skip
  '</html>' skip.
